/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

(function($) {
     $.api = function( opciones_user, datos){
        var opciones = $.extend( $.api.op_default , opciones_user);
        var  datosActividades = $.extend(  $.api.datosActividades , datos);
        for(var obj in datosActividades){
            construyeActividad(obj,datosActividades[obj].tipo);
        }

        /**
         *
         * Funcion que cambia los ID's de la pregunta, el boton
         * y el campo de retroalimentacion de cada una de las preguntas ("jspregunta")
         * de la actividad que se pasa como argumento (idActividad).
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad El atributo ID de la actividad a modificar.
         * @param tipo El tipo de actividad a construir.
         *
         * */
        function construyeActividad(idActividad,tipo){
            datosActividades[idActividad].total=$("[title='jspregunta']",$("#"+idActividad)).length;//Marco el total de actividades.

            $("[title='jspregunta']",$("#"+idActividad)).each(function(i){//Por cada pregunta..
                pregunta = $(this);
                pregunta.attr("id", idActividad+"__pregunta"+i);//Asigno ID especifico
                $("[alt='revisar']",pregunta).attr("id", idActividad+"__boton"+i)//Modifico boton de la pregunta
                $("[title='retroalimentacion']",pregunta).attr("id", idActividad+"__retro"+i);//Marcar la retroalimentacion.

                construyeRespuesta(idActividad,tipo,i);//Construye las posibles respuestas.

                datosActividades[idActividad].porContestar.push(idActividad+"__pregunta"+i);//Agregamos el ide de la pregunta para poder saber cuando ya contesto todas las preguntas de una actividad.
            });



        }

        /**
         * Funcion que dependiendo del tipo de actividad, manda a construir la pregunta.
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a modificar
         * @param tipo El tipo de ejercicio.
         * @param posicion La posici&oacute;n o numero de pregunta de la actividad.
         */
        function construyeRespuesta(idActividad,tipo,posicion){
            switch(tipo){
                case "textarea":
                    construyeTextArea(idActividad,posicion);
                    break;
                case "select":
                    construyeSelect(idActividad,posicion);
                    break;
                case "text":
                    construyeText(idActividad,posicion);
                    break;
                case "radiobutton":
                    construyeRadiobutton(idActividad,posicion);
                    break;
                case "checkbox":
                    contruyeCheckbox(idActividad,posicion);
                    break;
            }
        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo checkbox.
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function contruyeCheckbox(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("input:checkbox",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).attr("name", idActividad+"__respuesta"+posicion+"__"+i);
                $(this).attr("id", idActividad+"__respuesta"+posicion+"__"+i);

                $(this).val(datosActividades[idActividad].respuestas[posicion][i]);// El atributo value, tiene la respuesta correcta (true o false).
                $("#"+idActividad+"__pregunta"+posicion).append('<div style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+'__'+i+'"></div>');
                $("#"+idActividad+"__visual"+posicion+"__"+i).offset($(this).offset());
            });

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                // ------- Obtener idActividad y numero de pregunta -------------
                var datosR = this.id.toString().split("__boton");
                if(datosR.length<2)return;
                var idActividad = datosR[0];
                var nPregunta = datosR[1];
                var datosAct = datosActividades[idActividad];



                // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
                var hayText = true;//bandera para terminar el for
                var i=correctas=0;//indice y contador de correctas
                for(i=0;hayText;i++){
                    var respuesta = $("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']");//Obtengo el checkbox i
                    if(respuesta.length>0){//Si existe
                        $("#"+idActividad+"__visual"+nPregunta+"__"+i).offset(respuesta.offset());//Posicionamos la palomita.
                        if(""+respuesta.attr("checked")==respuesta.val()){//Si el atreibuto checked es igual al valor del checked, es correcta.
                            if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                                $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_bien+'"/>');
                            correctas++;
                        }else{
                            if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                                $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_mal+'"/>');
                        }
                    }else{
                        hayText = false;
                        i--;
                    }

                }

                // ---------- Obtengo el porcentaje obtenido de correctas --------------
                var porcentaje=0;
                if(i>0)
                    porcentaje = correctas*100/i;

                // ---------- Muestro la retroalimentacion textual  ---------
                if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                    var mensajes = obtenerMensaje(idActividad,nPregunta);
                    muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
                }
                return false;
            });

        }

        /**
         * Obtiene el los mensajes de la retroalimentaci&oacute;n textual de una pregunta espec&iacute;fica.
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad de la cual se obtendran los mensajes.
         * @param nPregunta El numero de pregunta para que obtenga los mensajes especificos si existen.
         * @retuen Array El arreglo de respuestas.
         **/
        function obtenerMensaje(idActividad,nPregunta){
            if(datosActividades[idActividad].mensajes[nPregunta]!=undefined){
                return datosActividades[idActividad].mensajes[nPregunta];
            }else{
                return datosActividades[idActividad].mensajes[0];
            }
        }

        /**
         * Muestra un mensaje especifico dependiendo del porcentaje obtenido dentro de
         * el elemento donde se mostrar&aacute; la retroalimentaci&oacute;n textual de la pregunta.
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param elementoJQ El elemento JQuery donde cargar&aacute; la retroalimentaci&oacute;n.
         * @param porcentaje El porcentaje obtenido al evaluar la pregunta.
         * @param mensajes Array con los diferentes mensajes a mostrar.
         **/
        function muestraMesnaje(elmentoJQ,porcentaje,mensajes){
            if(typeof mensajes[0] != "string"){//Si no es string quiere decir que mostrar&aacute; la retroalimentaci&oacute;n dependiendo de el porcentaje obtenido
                $.each(mensajes,function(m){
                    if(porcentaje<=this[0]){
                        elmentoJQ.html(this[1]);
                        return false;
                    }
                });
            }else{// Si el mensaje es una cadena, quiere decir que mostrar&aacute; la retroalimentaci&oacute;n en base a "bien(100%)" o "mal(menos del 100%)".
                if(porcentaje>99){
                    elmentoJQ.html(mensajes[1]);
                }else{
                    elmentoJQ.html(mensajes[0]);
                }
            }

        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo text.
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeText(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("input:text",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).attr("name", idActividad+"__respuesta"+posicion+"__"+i);
                $(this).attr("id", idActividad+"__respuesta"+posicion+"__"+i);

                $("#"+idActividad+"__pregunta"+posicion).append('<div style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+'__'+i+'"></div>');
                $("#"+idActividad+"__visual"+posicion+"__"+i).offset($(this).offset());
            });

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                // ------- Obtener idActividad y numero de pregunta -------------
                var datosR = this.id.toString().split("__boton");
                if(datosR.length<2)return;
                var idActividad = datosR[0];
                var nPregunta = datosR[1];
                var datosAct = datosActividades[idActividad];

                // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
                var respuestas = datosAct.respuestas[nPregunta];
                var hayText = true;//Bandera para terminar el for
                var correctas = 0;
                var i=0;
                for(i=0;hayText;i++){
                    if($("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']").length>0){
                        $("#"+idActividad+"__visual"+nPregunta+"__"+i).offset($("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']").offset());//Posicionamos la retroalimentacion visual
                        if(respuestas[i]==$("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']").val().toLowerCase()){
                            if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                                $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_bien+'"/>');
                            correctas++;
                        }else{
                            if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                                $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_mal+'"/>');
                        }
                    }else{
                        hayText = false;
                    }

                }
                i--;//Restarle uno para que sea el numero exacto de preguntas.

                // ---------- Obtengo el porcentaje obtenido de correctas --------------
                var porcentaje = correctas*100/i;

                // ---------- Muestro la retroalimentacion textual  ---------
                if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                    var mensajes = obtenerMensaje(idActividad,nPregunta);
                    muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
                }
                return false;
            });
        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo select.
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeSelect(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("select",$("#"+idActividad+"__pregunta"+posicion)).attr("name", idActividad+"__respuesta"+posicion);
            $("select",$("#"+idActividad+"__pregunta"+posicion)).attr("id", idActividad+"__respuesta"+posicion);

            $("#"+idActividad+"__pregunta"+posicion).append('<div style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+'"></div>');
            $("#"+idActividad+"__visual"+posicion).offset($("select",$("#"+idActividad+"__pregunta"+posicion)).offset());

            $("select option",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).val(i);
            });

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                // ------- Obtener idActividad y numero de pregunta -------------
                var datosR = this.id.toString().split("__boton");
                if(datosR.length<2)return;
                var idActividad = datosR[0];
                var nPregunta = datosR[1];
                var datosAct = datosActividades[idActividad];

                $("#"+idActividad+"__visual"+nPregunta).offset($("select[name='"+idActividad+"__respuesta"+nPregunta+"']").offset());//Posiciono la retroalimebtacion visual.

                // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
                correcta=$("select[name='"+idActividad+"__respuesta"+nPregunta+"']").val()==datosActividades[idActividad].respuestas[nPregunta];

                if(correcta){
                    if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                        $("#"+idActividad+"__visual"+nPregunta).html('<img src="'+opciones.ruta_imagen_bien+'"/>');
                }else{
                    if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                        $("#"+idActividad+"__visual"+nPregunta).html('<img src="'+opciones.ruta_imagen_mal+'"/>');
                }

                // ---------- Obtengo el porcentaje obtenido de correctas --------------
                var porcentaje = correcta?100:0;

                // ---------- Muestro la retroalimentacion textual  ---------
                if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                    var mensajes = obtenerMensaje(idActividad,nPregunta);
                    muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
                }
                return false;
            });

        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo radio.
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeRadiobutton(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("input:radio",$("#"+idActividad+"__pregunta"+posicion)).attr("name", idActividad+"__respuesta"+posicion);
            $("input:radio",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).val(i);
            });

            $("#"+idActividad+"__pregunta"+posicion).append('<div style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+'"></div>');

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                // ------- Obtener idActividad y numero de pregunta -------------
                var datosR = this.id.toString().split("__boton");
                if(datosR.length<2)return;
                var idActividad = datosR[0];
                var nPregunta = datosR[1];
                var datosAct = datosActividades[idActividad];

                // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
                var correcta = $("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").val() == datosActividades[idActividad].respuestas[nPregunta];

                if(correcta){
                    if(datosAct.rvisual){//Si puede mostrar retroalimentacion visual
                        $("#"+idActividad+"__visual"+nPregunta).html('<img src="'+opciones.ruta_imagen_bien+'"/>');
                        $("#"+idActividad+"__visual"+nPregunta).offset($("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").offset());
                    }
                }else{
                    if(datosAct.rvisual){//Si puede mostrar retroalimentacion visual
                        if($("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").val()==undefined){
                            alert("Debes seleccionar al menos una respuesta");
                            return false;
                        }
                        $("#"+idActividad+"__visual"+nPregunta).html('<img src="'+opciones.ruta_imagen_mal+'"/>');
                        $("#"+idActividad+"__visual"+nPregunta).offset($("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").offset());
                    }
                }

                // ---------- Obtengo el porcentaje obtenido de correctas --------------
                var porcentaje = correcta?100:0;

                // ---------- Muestro la retroalimentacion textual  ---------
                if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                    var mensajes = obtenerMensaje(idActividad,nPregunta);
                    muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
                }
                return false;
            });

        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo textarea.
         *
         * @autor Juan Manuel Mu&ntilde;oz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeTextArea(idActividad,posicion){

            /* ----- Colocar nombres e id ------ */
            $("textarea",$("#"+idActividad+"__pregunta"+posicion)).attr("name",idActividad+"__respuesta"+posicion);
            $("textarea",$("#"+idActividad+"__pregunta"+posicion)).attr("id",idActividad+"__respuesta"+posicion);

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                // ------- Obtener idActividad y numero de pregunta -------------
                var datosR = this.id.toString().split("__boton");
                if(datosR.length<2)return;
                var idActividad = datosR[0];
                var nPregunta = datosR[1];
                var datosAct = datosActividades[idActividad];

                // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
                prespuestas = datosAct.respuestas[nPregunta];
                var correctas = Array();
                for(var i=0;i<prespuestas.length;i++){
                    correctas[i]=0;
                }

                var palabras = $("#"+idActividad+"__respuesta"+nPregunta).val().toLowerCase().split(" ");
                var buenas = 0;
                $.each(palabras,function(i){
                    if(palabras[i]!=""){
                        if(contienePalabra(palabras[i],prespuestas,correctas))
                            buenas++;
                    }
                });

                buenas = 0;
                $.each(correctas,function(){
                    buenas += this;
                });
                //alert("obtubiste: "+correctas+" total: "+buenas);

                // ---------- Obtengo el porcentaje obtenido de correctas --------------
                var porcentaje = 0;
                if(correctas.length>0)
                    porcentaje = buenas*100/correctas.length;

                // ---------- Muestro la retroalimentacion textual  ---------
                if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                    var mensajes = obtenerMensaje(idActividad,nPregunta);
                    muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
                }
                return false;
            });
        }

        function contienePalabra(palabra, prespuestas,correctas){
            for(var i=0;i<prespuestas.length;i++){
                for(var j=0;j<prespuestas[i].length;j++){
                    if(palabra==prespuestas[i][j].toLowerCase()){
                        correctas[i]=1;
                        return true;
                    }
                }
            }
            return false;
        }

        
        //var mensaje = $.api.transformar(mensaje);
        //alert(opciones.inicio_str + mensaje + opciones.final_str);
    }

    $.api.opciones = undefined

    $.api.datosActividades = undefined;

    $.api.op_default = {
        ruta_imagen_bien : "images/acierto.gif",
        ruta_imagen_mal: "images/error.gif"
    }
})(jQuery);
